<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { computed, inject, ref, watch } from 'vue';
import { storeToRefs } from 'pinia';
import { VueDraggable } from 'vue-draggable-plus';
import { useI18n } from 'vue-i18n';
import { adminMenuEnum, handleModeEnum, paneTypes, userType } from '@/enums/enums';
import useShareDBDoc from '@/hooks/useShareDBDoc';
import { useScheduleStore } from '@/stores/schedule';
import BoardInformation from '@/components/general/BoardInformation.vue';
import Modal from '@/components/general/Modal.vue';
import AdminMenuButton from '@/components/general/AdminMenu.vue';
import LoadingSpinner from '@/components/general/LoadingSpinner.vue';
import Column from '@/components/schedule/Column.vue';
import ColumnEditor from '@/components/schedule/ColumnEditor.vue';
import CommentSidebar from '@/components/general/CommentSidebar.vue';
import { getCookie } from '@/lib/utils';
import ColumnSelector from '@/components/schedule/ColumnSelector.vue';
import useSchedule from '@/hooks/useSchedule';
import Favorite from '@/components/general/Favorite.vue';
import Dropdown from '@/components/general/Dropdown.vue';
import PaneDropdown from '@/components/account/PaneDropdown.vue';
import PostEditor from '@/components/general/PostEditor.vue';

const { t } = useI18n();
const $t = t;

const init = useShareDBDoc(paneTypes.SCHEDULE)
const store = useScheduleStore();
const { createPost } = useSchedule();

const { getHeadline, getSubHeadline, getUserType, getStyle, getFullUsable, dataSet: getDataSet, getMovable, showComments, postIndex, columnIndex, file, showAdministrationSidebar, getOneColumn, openColumnId, openPostId, insertAtIndex, handleMode, openMenu } = storeToRefs(store);
let configuration = inject<any>('configuration');
let apiServer = configuration.apiServer;

document.title = $t('general.variables.name');

watch(getHeadline, (headline) => {
    document.title = headline;
})

const containerRef = ref<HTMLDivElement>();

const onColumnDrag = (e: any) => {
    console.log({ e });
    store.editColumnPosition({ columnIndex: e.oldIndex, newColumnIndex: e.newIndex });
    resetDropdown();
}

const isColumnEditorModalOpen = ref(false);
const showColumnEditor = (value: boolean, insertAt: number) => {
    if (!getOneColumn.value) {
        isColumnEditorModalOpen.value = value;
        insertAtIndex.value = insertAt;
    }
};

const closeColumnEditor = () => {
    if (!getOneColumn.value)
        isColumnEditorModalOpen.value = false;
}

const resetDropdown = (e?: any) => {
    if (e && (e.path || e.composedPath())) {
        let path = e.path || e.composedPath();
        if (path.findIndex((element: any) => { return element.id?.includes("color-swatch") }) !== -1) {
            return;
        }
        if (path.findIndex((element: any) => { return element.id?.includes("more_column_header_") }) === -1) {
            openColumnId.value = '';
        }
        if (path.findIndex((element: any) => { return element.id?.includes("more_post_") }) === -1) {
            openPostId.value = '';
        }
    }
    else {
        openColumnId.value = '';
        openPostId.value = '';
    }
}

const closeComments = () => {
    postIndex.value = -1;
    columnIndex.value = -1;
    showComments.value = false;
}

const pasteText = ref('');
const pasteContent = async (event: ClipboardEvent) => {
    if (getFullUsable.value && !isColumnEditorModalOpen.value && !showComments.value && !isColumnSelectorOpen.value && openMenu.value !== adminMenuEnum.SETTINGS) {
        let item = event.clipboardData;
        if (item && item.items[0].type.indexOf("image") >= 0) {
            file.value = item.items[0].getAsFile();
            showColumnSelector(true);
        } else if (item && item.items[0].type.indexOf("text") >= 0) {
            //@ts-ignore
            pasteText.value = document.createElement('div').appendChild(document.createTextNode(item.getData("text"))).parentNode!.innerHTML;
            showColumnSelector(true);
        }
    }
};

const isColumnSelectorOpen = ref(false);
const showColumnSelector = (value: boolean) => {
    isColumnSelectorOpen.value = value;
}

const isHeadlineModalOpen = ref(false);
const showHeadlineModal = (value: boolean) => {
    isHeadlineModalOpen.value = value;
}

const isSubHeadlineModalOpen = ref(false);
const showSubHeadlineModal = (value: boolean) => {
    isSubHeadlineModalOpen.value = value;
}

const selectedColumn = async () => {
    if (file.value) {
        await createPost({});
    } else {
        await createPost({ text: pasteText.value });
    }
    close();
}

const close = () => {
    showColumnSelector(false);
    pasteText.value = '';
    file.value = null;
}

const calculateVh = () => {
    let height = window.visualViewport !== void 0 ? window?.visualViewport?.height : window.innerHeight;
    height = height ? height : 0;
    let vh = height * 0.01;
    document.documentElement.style.setProperty('--vh', vh + 'px');
}

const resizeCalculation = () => {
    calculateVh();

}

const closeEdit = () => {
    handleMode.value = handleModeEnum.NONE;
}

// Initial calculation
calculateVh();

// Re-calculate on resize
window.addEventListener('resize', resizeCalculation);

// Re-calculate on device orientation change
window.addEventListener('orientationchange', calculateVh);

const isTouch = computed(() => {
  return (typeof document !== 'undefined' && 'ontouchstart' in document.documentElement)
});

const columns = computed(() => {
    const arr:any[] = [];
    if (getDataSet.value) {
        getDataSet.value.forEach((element: any, index: number) => {
            if (element && ((getUserType.value === userType.USER && (element?.visible)) || (getUserType.value !== userType.USER))) {
                arr.push({ element, index });
            }
        });
    }
    return arr.sort((a: any, b: any) => a.index - b.index);
});

const startMove = (event:any) => {
    setTimeout(() => {
        event.item.classList.remove('animate-element-wiggle');
        event.item.style.opacity = '0.5';
    }, 20)
}

const resetToDefault = (event:any) => {
     event.item.style.opacity = '';
}

</script>
<template>
    <div @paste="pasteContent" @click="(e) => { resetDropdown(e) }" class="min-w-screen">
        <nav class="bg-white min-h-20 max-h-20 h-20 flex flex-row">
            <div class="pl-7 h-20 pt-5">
                <div :class="['select-none', getStyle?.font ? getStyle.font : '']" class="flex flex-col">
                    <Tooltip :tooltip="getHeadline" :offset="10" width="max-w-96">
                        <div class="text-2xl line-clamp-1 text-ellipsis w-full h-8">{{ getHeadline }}</div>
                    </Tooltip>
                    <div class="w-fit">
                        <Tooltip :tooltip="getSubHeadline" placement="bottom" width="max-w-96">
                            <div class="line-clamp-1 text-ellipsis h-6">{{ getSubHeadline }}</div>
                        </Tooltip>
                    </div>
                </div>
            </div>
            <div class="ml-auto min-w-80">
                <div class="flex flex-row min-h-20 max-h-20 h-20 p-4 gap-2 justify-end">
                    <div class="size-12 block hover:bg-gray-200 rounded-md" v-if="getCookie('Token')">
                        <Favorite size="size-12 pt-1" />
                    </div>
                    <Tooltip :tooltip="$t('adminMenu.questionmark.label')">
                        <a class="size-12 hover:bg-gray-200 text-gray-500 rounded-md block text-center align-middle leading-[48px] text-2xl hover:text-gray-500 hover:no-underline"
                            :href="$t('indexPage.faq')" rel="noopener" target="_blank"><i
                                class="ri-question-line ri-sm leading-12 align-middle"></i></a>
                    </Tooltip>
                    <Dropdown placement="bottom-end">
                        <template #button>
                            <Tooltip :tooltip="$t('tooltips.information')">
                                <button
                                    class="size-12 hover:bg-gray-200 text-gray-500 rounded-md block text-center align-middle leading-[48px] text-2xl hover:no-underline"><i
                                        class="ri-information-2-line ri-sm leading-12 align-middle"></i></button>
                            </Tooltip>
                        </template>
                        <BoardInformation cls="w-fit" />
                    </Dropdown>
                    <AdminMenuButton cls="" :name="getHeadline" />
                    <Dropdown placement="bottom-end" width="min-w-64 max-w-64" v-if="getCookie('Token')">
                        <template #button>
                            <Tooltip :tooltip="$t('general.variables.account.sg')">
                                <button
                                    class="size-12 hover:bg-gray-200 text-gray-500 rounded-md block text-center align-middle leading-[48px] text-2xl hover:no-underline"><i
                                        class="ri-user-line ri-sm leading-12 align-middle"></i></button>
                            </Tooltip>
                        </template>
                        <template v-slot="{ close }">
                            <PaneDropdown :close="close" />
                        </template>
                    </Dropdown>
                </div>
            </div>
        </nav>
        <div id="content" class="p-2 overflow-auto max-h-[calc(100dvh-80px)]"
            :class="[getStyle?.font ? getStyle.font : '']"
            :style="{ background: getStyle != null && getStyle.backgroundImage != null ? `url(${apiServer}` + getStyle.backgroundImage + ')' : (getStyle != null && getStyle.backgroundColor != null ? getStyle.backgroundColor : 'white') }">
            <div class="flex flex-row flex-nowrap gap-10 p-4">
                <div class="w-12" v-if="getFullUsable && !getOneColumn">
                    <div class="mt-4">
                        <div class="text-center relative box-border transition duration-100 ease-in-out rounded-lg bg-accent1-default hover:bg-accent1-hover text-accent1-text size-12 p-1"
                            @click="showColumnEditor(true, 0)">
                            <Tooltip :tooltip="$t('contentPage.column.add')" :offset="10"><i
                                    class="ri-add-line ri-3x text-2xl align-middle leading-10 w-10 -ml-px text-center"></i>
                            </Tooltip>
                        </div>
                    </div>
                </div>
                <VueDraggable :animation="250" class="flex flex-row flex-nowrap gap-10" :modelValue="columns"
                    @end="onColumnDrag" group="columns" handle=".header-handle" :disabled="!getMovable"
                    :delay="250" :delayOnTouchOnly=true :dragClass="isTouch? 'hidden' : ''" 
                    :chosenClass="isTouch? 'animate-element-wiggle' : ''" 
                    :onUnchoose="resetToDefault" @start="startMove">
                    <Column :key="element.element.id" :column="element.element" :columnIndex="element.index" :columnCount="getDataSet!.length"
                        v-for="(element) in columns" />
                </VueDraggable>
                <div class="pr-5 ml-2" v-if="getFullUsable && !getOneColumn">
                    <div class="mt-4">
                        <div class="text-center relative box-border transition duration-100 ease-in-out rounded-lg bg-accent1-default hover:bg-accent1-hover text-accent1-text size-12 p-1"
                            @click="showColumnEditor(true, -1)">
                            <Tooltip :tooltip="$t('contentPage.column.add')" :offset="10"><i
                                    class="ri-add-line ri-3x text-2xl align-middle leading-10 w-10 -ml-px text-center"></i>
                            </Tooltip>
                        </div>
                    </div>
                </div>
            </div>
            <LoadingSpinner />
            <ColumnEditor @close="closeColumnEditor" v-if="isColumnEditorModalOpen" />
            <CommentSidebar @close="closeComments" v-if="postIndex > -1 && columnIndex > -1 && showComments" />
            <ColumnSelector @close="close" @selected="selectedColumn" v-if="isColumnSelectorOpen" />
            <Modal v-if="isHeadlineModalOpen" @close="showHeadlineModal(false)"
                :labelCancel="$t('general.buttons.close')">
                <div class="text-xl" v-html="getHeadline"></div>
            </Modal>
            <Modal v-if="isSubHeadlineModalOpen" @close="showSubHeadlineModal(false)"
                :labelCancel="$t('general.buttons.close')">
                <div class="text-lg" v-html="getSubHeadline"></div>
            </Modal>
            <PostEditor v-if="handleMode === handleModeEnum.ADD || handleMode === handleModeEnum.EDIT"
                @close="closeEdit" />
        </div>
    </div>
</template>
<style scoped>
.subline {
    overflow: hidden;
    text-overflow: ellipsis;
    word-wrap: break-word;
    display: block;
    line-height: 1em;
    /* a */
    max-height: 3em;
    padding-bottom: 4px;
}

@supports (-webkit-touch-callout: none) {

    /* CSS specific to iOS devices */
    .fullheight {
        height: calc(-webkit-fill-available - 80px);
    }
}

@supports not (-webkit-touch-callout: none) {

    /* CSS for other than iOS devices */
    .fullheight {
        height: calc(100vh - 80px);
    }
}

.animate-element-wiggle {
    opacity: 0.5;
    animation: wiggle 1.5s linear;
}

@keyframes wiggle {

    0%,
    7% {
        transform: rotateZ(0);
    }

    15% {
        transform: rotateZ(-5deg);
    }

    20% {
        transform: rotateZ(3deg);
    }

    25% {
        transform: rotateZ(-3deg);
    }

    30% {
        transform: rotateZ(2deg);
    }

    35% {
        transform: rotateZ(-1deg);
    }

    40%,
    100% {
        transform: rotateZ(0);
    }
}
</style>